//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: kava/hard/v1beta1/tx.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Msg defines the hard Msg service.
///
/// Usage: instantiate `Kava_Hard_V1beta1_MsgClient`, then call methods of this protocol to make API calls.
internal protocol Kava_Hard_V1beta1_MsgClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Kava_Hard_V1beta1_MsgClientInterceptorFactoryProtocol? { get }

  func deposit(
    _ request: Kava_Hard_V1beta1_MsgDeposit,
    callOptions: CallOptions?
  ) -> UnaryCall<Kava_Hard_V1beta1_MsgDeposit, Kava_Hard_V1beta1_MsgDepositResponse>

  func withdraw(
    _ request: Kava_Hard_V1beta1_MsgWithdraw,
    callOptions: CallOptions?
  ) -> UnaryCall<Kava_Hard_V1beta1_MsgWithdraw, Kava_Hard_V1beta1_MsgWithdrawResponse>

  func borrow(
    _ request: Kava_Hard_V1beta1_MsgBorrow,
    callOptions: CallOptions?
  ) -> UnaryCall<Kava_Hard_V1beta1_MsgBorrow, Kava_Hard_V1beta1_MsgBorrowResponse>

  func repay(
    _ request: Kava_Hard_V1beta1_MsgRepay,
    callOptions: CallOptions?
  ) -> UnaryCall<Kava_Hard_V1beta1_MsgRepay, Kava_Hard_V1beta1_MsgRepayResponse>

  func liquidate(
    _ request: Kava_Hard_V1beta1_MsgLiquidate,
    callOptions: CallOptions?
  ) -> UnaryCall<Kava_Hard_V1beta1_MsgLiquidate, Kava_Hard_V1beta1_MsgLiquidateResponse>
}

extension Kava_Hard_V1beta1_MsgClientProtocol {
  internal var serviceName: String {
    return "kava.hard.v1beta1.Msg"
  }

  /// Deposit defines a method for depositing funds to hard liquidity pool.
  ///
  /// - Parameters:
  ///   - request: Request to send to Deposit.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func deposit(
    _ request: Kava_Hard_V1beta1_MsgDeposit,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Kava_Hard_V1beta1_MsgDeposit, Kava_Hard_V1beta1_MsgDepositResponse> {
    return self.makeUnaryCall(
      path: "/kava.hard.v1beta1.Msg/Deposit",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeDepositInterceptors() ?? []
    )
  }

  /// Withdraw defines a method for withdrawing funds from hard liquidity pool.
  ///
  /// - Parameters:
  ///   - request: Request to send to Withdraw.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func withdraw(
    _ request: Kava_Hard_V1beta1_MsgWithdraw,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Kava_Hard_V1beta1_MsgWithdraw, Kava_Hard_V1beta1_MsgWithdrawResponse> {
    return self.makeUnaryCall(
      path: "/kava.hard.v1beta1.Msg/Withdraw",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeWithdrawInterceptors() ?? []
    )
  }

  /// Borrow defines a method for borrowing funds from hard liquidity pool.
  ///
  /// - Parameters:
  ///   - request: Request to send to Borrow.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func borrow(
    _ request: Kava_Hard_V1beta1_MsgBorrow,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Kava_Hard_V1beta1_MsgBorrow, Kava_Hard_V1beta1_MsgBorrowResponse> {
    return self.makeUnaryCall(
      path: "/kava.hard.v1beta1.Msg/Borrow",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeBorrowInterceptors() ?? []
    )
  }

  /// Repay defines a method for repaying funds borrowed from hard liquidity pool.
  ///
  /// - Parameters:
  ///   - request: Request to send to Repay.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func repay(
    _ request: Kava_Hard_V1beta1_MsgRepay,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Kava_Hard_V1beta1_MsgRepay, Kava_Hard_V1beta1_MsgRepayResponse> {
    return self.makeUnaryCall(
      path: "/kava.hard.v1beta1.Msg/Repay",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeRepayInterceptors() ?? []
    )
  }

  /// Liquidate defines a method for attempting to liquidate a borrower that is over their loan-to-value.
  ///
  /// - Parameters:
  ///   - request: Request to send to Liquidate.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func liquidate(
    _ request: Kava_Hard_V1beta1_MsgLiquidate,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Kava_Hard_V1beta1_MsgLiquidate, Kava_Hard_V1beta1_MsgLiquidateResponse> {
    return self.makeUnaryCall(
      path: "/kava.hard.v1beta1.Msg/Liquidate",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeLiquidateInterceptors() ?? []
    )
  }
}

internal protocol Kava_Hard_V1beta1_MsgClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'deposit'.
  func makeDepositInterceptors() -> [ClientInterceptor<Kava_Hard_V1beta1_MsgDeposit, Kava_Hard_V1beta1_MsgDepositResponse>]

  /// - Returns: Interceptors to use when invoking 'withdraw'.
  func makeWithdrawInterceptors() -> [ClientInterceptor<Kava_Hard_V1beta1_MsgWithdraw, Kava_Hard_V1beta1_MsgWithdrawResponse>]

  /// - Returns: Interceptors to use when invoking 'borrow'.
  func makeBorrowInterceptors() -> [ClientInterceptor<Kava_Hard_V1beta1_MsgBorrow, Kava_Hard_V1beta1_MsgBorrowResponse>]

  /// - Returns: Interceptors to use when invoking 'repay'.
  func makeRepayInterceptors() -> [ClientInterceptor<Kava_Hard_V1beta1_MsgRepay, Kava_Hard_V1beta1_MsgRepayResponse>]

  /// - Returns: Interceptors to use when invoking 'liquidate'.
  func makeLiquidateInterceptors() -> [ClientInterceptor<Kava_Hard_V1beta1_MsgLiquidate, Kava_Hard_V1beta1_MsgLiquidateResponse>]
}

internal final class Kava_Hard_V1beta1_MsgClient: Kava_Hard_V1beta1_MsgClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Kava_Hard_V1beta1_MsgClientInterceptorFactoryProtocol?

  /// Creates a client for the kava.hard.v1beta1.Msg service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Kava_Hard_V1beta1_MsgClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Msg defines the hard Msg service.
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Kava_Hard_V1beta1_MsgProvider: CallHandlerProvider {
  var interceptors: Kava_Hard_V1beta1_MsgServerInterceptorFactoryProtocol? { get }

  /// Deposit defines a method for depositing funds to hard liquidity pool.
  func deposit(request: Kava_Hard_V1beta1_MsgDeposit, context: StatusOnlyCallContext) -> EventLoopFuture<Kava_Hard_V1beta1_MsgDepositResponse>

  /// Withdraw defines a method for withdrawing funds from hard liquidity pool.
  func withdraw(request: Kava_Hard_V1beta1_MsgWithdraw, context: StatusOnlyCallContext) -> EventLoopFuture<Kava_Hard_V1beta1_MsgWithdrawResponse>

  /// Borrow defines a method for borrowing funds from hard liquidity pool.
  func borrow(request: Kava_Hard_V1beta1_MsgBorrow, context: StatusOnlyCallContext) -> EventLoopFuture<Kava_Hard_V1beta1_MsgBorrowResponse>

  /// Repay defines a method for repaying funds borrowed from hard liquidity pool.
  func repay(request: Kava_Hard_V1beta1_MsgRepay, context: StatusOnlyCallContext) -> EventLoopFuture<Kava_Hard_V1beta1_MsgRepayResponse>

  /// Liquidate defines a method for attempting to liquidate a borrower that is over their loan-to-value.
  func liquidate(request: Kava_Hard_V1beta1_MsgLiquidate, context: StatusOnlyCallContext) -> EventLoopFuture<Kava_Hard_V1beta1_MsgLiquidateResponse>
}

extension Kava_Hard_V1beta1_MsgProvider {
  internal var serviceName: Substring { return "kava.hard.v1beta1.Msg" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "Deposit":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Kava_Hard_V1beta1_MsgDeposit>(),
        responseSerializer: ProtobufSerializer<Kava_Hard_V1beta1_MsgDepositResponse>(),
        interceptors: self.interceptors?.makeDepositInterceptors() ?? [],
        userFunction: self.deposit(request:context:)
      )

    case "Withdraw":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Kava_Hard_V1beta1_MsgWithdraw>(),
        responseSerializer: ProtobufSerializer<Kava_Hard_V1beta1_MsgWithdrawResponse>(),
        interceptors: self.interceptors?.makeWithdrawInterceptors() ?? [],
        userFunction: self.withdraw(request:context:)
      )

    case "Borrow":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Kava_Hard_V1beta1_MsgBorrow>(),
        responseSerializer: ProtobufSerializer<Kava_Hard_V1beta1_MsgBorrowResponse>(),
        interceptors: self.interceptors?.makeBorrowInterceptors() ?? [],
        userFunction: self.borrow(request:context:)
      )

    case "Repay":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Kava_Hard_V1beta1_MsgRepay>(),
        responseSerializer: ProtobufSerializer<Kava_Hard_V1beta1_MsgRepayResponse>(),
        interceptors: self.interceptors?.makeRepayInterceptors() ?? [],
        userFunction: self.repay(request:context:)
      )

    case "Liquidate":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Kava_Hard_V1beta1_MsgLiquidate>(),
        responseSerializer: ProtobufSerializer<Kava_Hard_V1beta1_MsgLiquidateResponse>(),
        interceptors: self.interceptors?.makeLiquidateInterceptors() ?? [],
        userFunction: self.liquidate(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Kava_Hard_V1beta1_MsgServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'deposit'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeDepositInterceptors() -> [ServerInterceptor<Kava_Hard_V1beta1_MsgDeposit, Kava_Hard_V1beta1_MsgDepositResponse>]

  /// - Returns: Interceptors to use when handling 'withdraw'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeWithdrawInterceptors() -> [ServerInterceptor<Kava_Hard_V1beta1_MsgWithdraw, Kava_Hard_V1beta1_MsgWithdrawResponse>]

  /// - Returns: Interceptors to use when handling 'borrow'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeBorrowInterceptors() -> [ServerInterceptor<Kava_Hard_V1beta1_MsgBorrow, Kava_Hard_V1beta1_MsgBorrowResponse>]

  /// - Returns: Interceptors to use when handling 'repay'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeRepayInterceptors() -> [ServerInterceptor<Kava_Hard_V1beta1_MsgRepay, Kava_Hard_V1beta1_MsgRepayResponse>]

  /// - Returns: Interceptors to use when handling 'liquidate'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeLiquidateInterceptors() -> [ServerInterceptor<Kava_Hard_V1beta1_MsgLiquidate, Kava_Hard_V1beta1_MsgLiquidateResponse>]
}
